/*
 * songs - a little tool to record and mix audio files.
 *
 * public domain
 *
 * http://sed.free.fr/songs
 */

#include "help_gui.h"

#include <gtk/gtk.h>

#include "error.h"
#include "version.h"

void help_gui(void)
{
  reset_error();
  add_error_char("Help system not done yet.\nSorry.\n");
  display_error();
}

static int about_gui_on = 0;

static void about_off(void)
{
  about_gui_on = 0;
}

void about_gui(void)
{
  extern GtkWidget *main_win;
  GtkWidget *about;

  if (about_gui_on)
    return;

  /* error used as buffer */
  reset_error();
  add_error_char("Songs ");
  add_error_char(VERSION);
  add_error_char("\n\nWebsite: ");
  add_error_char(WEBSITE);
  add_error_char("\n\nSongs is a little tool used to record and mix audio files.\n");
  add_error_char("See the website for the latest version and documentation.\n");
  add_error_char("It is currently a beta software, not very full featured.\n");
  add_error_char("\nSongs is in the public domain.\n");
  add_error_char("\nCompressor code ripped and adapted from sc1_1425 coming from ");
  add_error_char("swh-plugins-0.4.11.tar.gz (see http://plugin.org.uk/).\n");
  add_error_char("\nSongs is dedicated to Paulette Roux\n(January 19th, 1920 - January 1st, 2004).\n");

  about = gtk_message_dialog_new(GTK_WINDOW(main_win), GTK_DIALOG_DESTROY_WITH_PARENT,
	GTK_MESSAGE_INFO, GTK_BUTTONS_OK, "%s", get_error());

  g_signal_connect(about, "response", G_CALLBACK(gtk_widget_destroy), 0);
  g_signal_connect(about, "destroy", G_CALLBACK(about_off), 0);

  gtk_widget_show_all(about);

  about_gui_on = 1;
}
