/*
 * songs - a little tool to record and mix audio files.
 *
 * public domain
 *
 * http://sed.free.fr/songs
 */

#ifndef _INPUT_H_
#define _INPUT_H_

#include "channel.h"

typedef struct input {
  channel_common c;
  int input_type;
  int size;
  void *data;
  char *file;
  int file_size;
  char *view_min;
  char *view_max;
  void *stream;
  void (*open_stream)(struct input *);
  void (*close_stream)(struct input *);
  void (*float_stream)(struct input *, float *, int);
} input;

void delete_input(input *);

int mono_short_little_feed_buffer_short_mono(input *, short *, int, int);
int mono_short_little_feed_buffer_float_mono(input *, float *, int, int);
int mono_short_little_feed_buffer_short_stereo(input *, short *, int, int);
int mono_short_little_feed_buffer_float_stereo(input *, float *, int, int);
int stereo_left_short_little_feed_buffer_short_mono(input *, short *, int, int);
int stereo_left_short_little_feed_buffer_float_mono(input *, float *, int, int);
int stereo_left_short_little_feed_buffer_short_stereo(input *, short *, int, int);
int stereo_left_short_little_feed_buffer_float_stereo(input *, float *, int, int);
int stereo_right_short_little_feed_buffer_short_mono(input *, short *, int, int);
int stereo_right_short_little_feed_buffer_float_mono(input *, float *, int, int);
int stereo_right_short_little_feed_buffer_short_stereo(input *, short *, int, int);
int stereo_right_short_little_feed_buffer_float_stereo(input *, float *, int, int);

int mono_float_feed_buffer_short_mono(input *, short *, int, int);
int mono_float_feed_buffer_float_mono(input *, float *, int, int);
int mono_float_feed_buffer_short_stereo(input *, short *, int, int);
int mono_float_feed_buffer_float_stereo(input *, float *, int, int);
int stereo_left_float_feed_buffer_short_mono(input *, short *, int, int);
int stereo_left_float_feed_buffer_float_mono(input *, float *, int, int);
int stereo_left_float_feed_buffer_short_stereo(input *, short *, int, int);
int stereo_left_float_feed_buffer_float_stereo(input *, float *, int, int);
int stereo_right_float_feed_buffer_short_mono(input *, short *, int, int);
int stereo_right_float_feed_buffer_float_mono(input *, float *, int, int);
int stereo_right_float_feed_buffer_short_stereo(input *, short *, int, int);
int stereo_right_float_feed_buffer_float_stereo(input *, float *, int, int);

int input_first_point(input *);
int input_last_point(input *);

void input_reset(input *);

input *new_input(char *, int);

void cleanup_input(void);

#endif /* _INPUT_H_ */
