/*
 * songs - a little tool to record and mix audio files.
 *
 * public domain
 *
 * http://sed.free.fr/songs
 */

#include <stdio.h>
#include <stdlib.h>

#include "endian.h"
#include "error.h"
#include "mixer.h"
#include "gui.h"
#include "input.h"
#include "memmap.h"

int main(int n, char **v)
{
  if (sizeof(int) < sizeof(void *)) {
    fprintf(stderr, "Sorry, on your machine sizeof(int) < sizeof(void *)\n");
    fprintf(stderr, "the program can't handle it.\n");
    return 1;
  }

  find_endianness();

  open_error();

  main_mixer = new_mixer(MIXER_TYPE_16B_STEREO_INTERNAL_FLOAT);
  if (!main_mixer) {
    oom();
    display_error();
    return 1;
  }

  main_mixer->minimum_sample = -10*4096;

  gui(n, v);

  /* the mixer has been deleted inside the gui */

  close_error();

  cleanup_input();
  cleanup_map();

  return 0;
}
