/*
 * songs - a little tool to record and mix audio files.
 *
 * public domain
 *
 * http://sed.free.fr/songs
 */

#ifndef _MARK_GUI_H_
#define _MARK_GUI_H_

#define MARK_HEIGHT	60

typedef struct mark {
  int on;
  int sample;
  char *name;
  void *gui;
  int y_position;
  void *gui_text;
  void *gui_edit;
  void *gui_edit_name;
  void *gui_edit_position;
  int gui_edit_on:1;
  unsigned long ev;
  int last_sample;
  int y_last_position;
  int last_mouse_x;
  int last_mouse_y;
  void (*mark_set)(struct mark *, int, int);
} mark;

extern mark **mark_list;
extern int mark_list_size;
extern int mark_list_maxsize;

void play_mark_on(int);
void play_mark_off(void);
void play_mark_set(int);
void play_mark_display(void);

mark *new_mark(char *, int);
void delete_mark(mark *);
void mark_on(mark *);
void mark_off(mark *);
mark *get_mark(char *);

mark *get_nth_mark(int);

void mark_gui_new(void);
void mark_gui_new_with_sample(int);
void mark_gui_edit(void);
void mark_gui_delete(void);
void mark_gui_goto(void);

void mark_gui_all_on(void);
void mark_gui_all_off(void);

void mark_gui_replace_marks(void);

#endif /* _MARK_GUI_H_ */
