/*
 * songs - a little tool to record and mix audio files.
 *
 * public domain
 *
 * http://sed.free.fr/songs
 */

#ifndef _AUDIO_MIXER_H_
#define _AUDIO_MIXER_H_

#include "channel.h"
#include "track.h"
#include "mark_gui.h"

/* mixer types */
#define MIXER_TYPE_16B_STEREO_INTERNAL_FLOAT	0

typedef struct mixer {
  track **tracks;
  int nb_tracks;
  int max_nb_tracks;
  int next_sample;
  int last_sample;
  int has_last_sample:1;
  int minimum_sample;
  int maximum_sample;
  track mixer_track;
  channel _raw_mix;
  int (*mix)(struct mixer *, void *, int);
  int (*float_mix)(struct mixer *, void *, int);
  int (*float_mono_mix)(struct mixer *, void *, int);
  int (*mix_mono)(struct mixer *, void *, int);
  void (*reset_effects)(struct mixer *);
  int gui_height;
  int gui_width;
  int gui_right_size;
} mixer;

extern mixer *main_mixer;

mixer *new_mixer(int);
void delete_mixer(mixer *);

int mixer_add_track(mixer *, track *c);
int mixer_sub_track(mixer *, track *c);

track *mixer_get_track(mixer *, int);

int first_audio_sample(void);
int last_audio_sample(void);

#endif /* _AUDIO_MIXER_H_ */
