/*
 * songs - a little tool to record and mix audio files.
 *
 * public domain
 *
 * http://sed.free.fr/songs
 */

#ifndef _TRACK_H_
#define _TRACK_H_

#include "channel.h"
#include "input.h"

typedef struct {
  channel *channel;
  input *input;
  int track_number;
  int mute:1;
  int gui_on:1;
  int drawing_x;
  int drawing_y;
  void *box;
  void *name_entry;
  void *label;
  void *mute_button;
  void *drawing_area;
} track;

track *new_track(char *, int);
void delete_track(track *);
void renumber_track(track *, int);

char *get_track_name(track *);
void set_track_name(track *t, char *);

#endif /* _TRACK_H_ */
