/*
 * songs - a little tool to record and mix audio files.
 *
 * public domain
 *
 * http://sed.free.fr/songs
 */

#include "yes_no_gui.h"

#include <gtk/gtk.h>

static void yes_event(int *yes, gint id)
{
  if (id == GTK_RESPONSE_YES)
    *yes = 1;
}

/* return 1 if yes, 0 if no */
int yes_no(void *parent, char *mess, void (*yes)(void), void (*no)(void))
{
  int rep=0;

  GtkWidget *dialog = gtk_message_dialog_new(parent,
	GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL,
	GTK_MESSAGE_QUESTION,
	GTK_BUTTONS_YES_NO,
	"%s", mess);

  g_signal_connect_swapped(dialog, "response", G_CALLBACK(yes_event), &rep);
  g_signal_connect(dialog, "response", G_CALLBACK(gtk_widget_destroy), dialog);
  g_signal_connect(dialog, "destroy", G_CALLBACK(gtk_main_quit), 0);

  gtk_widget_show_all(dialog);

  gtk_main();

  if (rep) {
    if (yes)
      yes();
  } else {
    if (no)
      no();
  }

  return rep;
}
